/*
  Copyright (c) 2012, Matthias Schiffer <mschiffer@universe-factory.net>
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


#ifndef _FFD_TLV_H_
#define _FFD_TLV_H_

#include "types.h"


typedef enum _ffd_tlv_type_t {
	TLV_PAD1 = 0,
	TLV_PADN,
	TLV_ACK_REQ,
	TLV_ACK,
	TLV_HELLO,
	TLV_IHU,
	TLV_NODE_ID,
	TLV_RESERVED,
	TLV_UPDATE,
	TLV_ANNOUNCE_REQ,
	TLV_SEQNO_REQ,
} ffd_tlv_type_t;

typedef enum _ffd_addr_enc_t {
	ADDR_ENC_UNSPEC = 0,
	ADDR_ENC_IPV4,
	ADDR_ENC_IPV6,
	ADDR_ENC_IPV6LL,
	ADDR_ENC_ETH,
} ffd_addr_enc_t;


typedef void (*ffd_tlv_cb)(ffd_tlv_type_t type, const void *data, size_t len, void *arg);


bool ffd_tlv_parse(const ffd_packet_t *packet, ffd_tlv_cb cb, void *arg);
void* ffd_tlv_add(ffd_packet_t *packet, size_t max_len, ffd_tlv_type_t type, size_t len);


#endif /* _FFD_TLV_H_ */
